Generic Image Library: dereference_iterator_adaptor< Iterator, DFn > Class Template Reference

###  | #  |

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Friends | List of all members
dereference_iterator_adaptor< Iterator, DFn > Class Template Reference
dereference_iterator_adaptor | Models

An adaptor over an existing iterator that provides for custom filter on dereferencing the object. Models: IteratorAdaptorConcept, PixelIteratorConcept. More...

`#include <pixel_iterator_adaptor.hpp>`

Inherits iterator_adaptor< dereference_iterator_adaptor< Iterator, DFn >, Iterator, DFn::value_type, std::iterator_traits< Iterator >::iterator_category, DFn::reference, use_default >.

## Public Types
typedef iterator_adaptor < dereference_iterator_adaptor < Iterator, DFn >, Iterator, typename DFn::value_type, typename std::iterator_traits < Iterator > ::iterator_category, typename DFn::reference, use_default > | parent_t
typedef DFn::result_type | reference
typedef std::iterator_traits < Iterator >::difference_type | difference_type
typedef DFn | dereference_fn

## Public Member Functions
template<typename Iterator1 >
| dereference_iterator_adaptor (const dereference_iterator_adaptor< Iterator1, DFn > &dit)
| dereference_iterator_adaptor (Iterator it, DFn deref_fn=DFn())
template<typename Iterator1 , typename DFn1 >
| dereference_iterator_adaptor (const dereference_iterator_adaptor< Iterator1, DFn1 > &it)
reference | operator[] (difference_type d) const
bool | operator> (const dereference_iterator_adaptor &p) const
bool | operator< (const dereference_iterator_adaptor &p) const
bool | operator>= (const dereference_iterator_adaptor &p) const
bool | operator<= (const dereference_iterator_adaptor &p) const
bool | operator== (const dereference_iterator_adaptor &p) const
bool | operator!= (const dereference_iterator_adaptor &p) const
Iterator & | base ()
const Iterator & | base () const
const DFn & | deref_fn () const

## Friends
template<typename Iterator1 , typename DFn1 >
class | dereference_iterator_adaptor
class | boost::iterator_core_access

## Detailed Description

### template<typename Iterator, typename DFn>
class boost::gil::dereference_iterator_adaptor< Iterator, DFn >

An adaptor over an existing iterator that provides for custom filter on dereferencing the object. Models: IteratorAdaptorConcept, PixelIteratorConcept.

## Member Function Documentation

reference operator[] | ( | difference_type | d | ) | const
| inline

For some reason operator[] provided by iterator_facade returns a custom class that is convertible to reference We require our own reference because it is registered in iterator_traits

The documentation for this class was generated from the following file:

- pixel_iterator_adaptor.hpp